# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 4.6.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ColumnMetadata(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'size': 'int',
        'missing': 'int',
        'unique': 'int',
        'unique_values': 'list[object]'
    }

    attribute_map = {
        'name': 'name',
        'size': 'size',
        'missing': 'missing',
        'unique': 'unique',
        'unique_values': 'uniqueValues'
    }

    def __init__(self, name=None, size=None, missing=None, unique=None, unique_values=None):  # noqa: E501
        """ColumnMetadata - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._size = None
        self._missing = None
        self._unique = None
        self._unique_values = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if size is not None:
            self.size = size
        if missing is not None:
            self.missing = missing
        if unique is not None:
            self.unique = unique
        if unique_values is not None:
            self.unique_values = unique_values

    @property
    def name(self):
        """Gets the name of this ColumnMetadata.  # noqa: E501


        :return: The name of this ColumnMetadata.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ColumnMetadata.


        :param name: The name of this ColumnMetadata.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def size(self):
        """Gets the size of this ColumnMetadata.  # noqa: E501


        :return: The size of this ColumnMetadata.  # noqa: E501
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this ColumnMetadata.


        :param size: The size of this ColumnMetadata.  # noqa: E501
        :type: int
        """

        self._size = size

    @property
    def missing(self):
        """Gets the missing of this ColumnMetadata.  # noqa: E501


        :return: The missing of this ColumnMetadata.  # noqa: E501
        :rtype: int
        """
        return self._missing

    @missing.setter
    def missing(self, missing):
        """Sets the missing of this ColumnMetadata.


        :param missing: The missing of this ColumnMetadata.  # noqa: E501
        :type: int
        """

        self._missing = missing

    @property
    def unique(self):
        """Gets the unique of this ColumnMetadata.  # noqa: E501


        :return: The unique of this ColumnMetadata.  # noqa: E501
        :rtype: int
        """
        return self._unique

    @unique.setter
    def unique(self, unique):
        """Sets the unique of this ColumnMetadata.


        :param unique: The unique of this ColumnMetadata.  # noqa: E501
        :type: int
        """

        self._unique = unique

    @property
    def unique_values(self):
        """Gets the unique_values of this ColumnMetadata.  # noqa: E501


        :return: The unique_values of this ColumnMetadata.  # noqa: E501
        :rtype: list[object]
        """
        return self._unique_values

    @unique_values.setter
    def unique_values(self, unique_values):
        """Sets the unique_values of this ColumnMetadata.


        :param unique_values: The unique_values of this ColumnMetadata.  # noqa: E501
        :type: list[object]
        """

        self._unique_values = unique_values

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ColumnMetadata):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
